/* tres minimal windframe sous forme LDG - very simple ldg windframe for MyAES

 MyAeS! (c) 2011 Olivier landemarre
*/


#include <stdio.h>
#include <gem.h>
#include <ldg.h>

#include "exttools.h"
#include "maes_dev.h"

WIDGETS_UTILS *widgets_utils;

#ifdef WITH_GCC_CALLBACK
#define NB_REG_CONTEXT 512
unsigned long _ldg_nb_regctx  = NB_REG_CONTEXT;
struct { unsigned long _r1, _r2, _r3, _r4;
	} _ldg_adr_regctx [ NB_REG_CONTEXT ];
long cdecl ldg_callback( void *f, ...);
#endif


void * call_Malloc(unsigned long size)
{ struct {unsigned long size; } args;
	args.size = size;
	return (void *) ldg_callback(widgets_utils->Malloc, args);
}

void call_Free(void *mem)
{ struct {void *mem; } args;
	args.mem = mem;
	(void) ldg_callback(widgets_utils->Free, args);
}

long call_extern_wind_get(long handle, long mode, INT16 *parm1, INT16 *parm2, INT16 *parm3, INT16 *parm4, void *client)
{
	struct {long handle; long mode; INT16 *parm1; INT16 *parm2; INT16 *parm3; INT16 *parm4; void *client; } args;
	args.handle = handle;
	args.mode = mode;
	args.parm1 = parm1;
	args.parm2 = parm2;
	args.parm3 = parm3;
	args.parm4 = parm4;
	args.client = client;
	return (long) ldg_callback(widgets_utils->extern_wind_get, args);
}

void call_myaes_G_TITLE_COLOR(long color)
{ struct {long color; } args;
	args.color = color;
	(void) ldg_callback(widgets_utils->myaes_G_TITLE_COLOR, args);
}

GRECT * call_get_win_rect(void *pt_win)
{ struct {void *pt_win; } args;
	args.pt_win = pt_win;
	return (GRECT *) ldg_callback(widgets_utils->get_win_rect, args);
}

void call_memcpy( void *dest, const void *source, unsigned long n )
{ struct {void *dest; const void *source; unsigned long n ; } args;
	args.dest = dest;
	args.source = source;
	args.n = n;
	(void) ldg_callback(widgets_utils->memcpy, args);
}

my_aes_WIN_VALUES * call_get_win_values(void *pt_win)
{ struct {void *pt_win; } args;
	args.pt_win = pt_win;
	return (my_aes_WIN_VALUES *) ldg_callback(widgets_utils->get_win_values, args);
}   

my_aes_WIN_STRINGS * call_get_win_strings(void *pt_win)
{ struct {void *pt_win; } args;
	args.pt_win = pt_win;
	return (my_aes_WIN_STRINGS *) ldg_callback(widgets_utils->get_win_strings, args);
} 

long call_get_win_id(void *pt_win)
{ struct {void *pt_win; } args;
	args.pt_win = pt_win;
	return (long) ldg_callback(widgets_utils->get_win_id, args);
} 

void * call_get_client(void *pt_win)
{ struct {void *pt_win; } args;
	args.pt_win = pt_win;
	return (void *) ldg_callback(widgets_utils->get_client, args);
}


#ifndef  FL3DIND
#define FL3DIND 0x0200
#define FL3DBAK 0x0400
#define NONE 0
#define LASTOB 0x20
#define HIDETREE 0x80
#define NORMAL 0



#endif



#define WDTOP      0 /* form/dialog */

#define WDSIZER1   1 /* BOXCHAR in tree WDTOP */
#define WDCLOSER   2 /* BOXCHAR in tree WDTOP */
#define WDFULLER   3 /* BOXCHAR in tree WDTOP */
#define WDSMALLE   4 /* BOXCHAR in tree WDTOP */
#define WDNAME     5 /* STRING in tree WDTOP */
#define WDSIZER2   6 /* BOXCHAR in tree WDTOP */
#define WDINFOS    7 /* BOXTEXT in tree WDTOP */

#define WDRIGHT    8 /* form/dialog */

#define WDTARROW   1 /* BOXCHAR in tree WDRIGHT */
#define WDVSLIDE   2 /* BOX in tree WDRIGHT */
#define WDSIZER5   3 /* BOXCHAR in tree WDRIGHT */
#define WDBARROW   4 /* BOXCHAR in tree WDRIGHT */


#define WDLEFT     13 /* form/dialog */

#define WDBOTTOM   14 /* form/dialog */

#define WDSIZER4   1 /* BOXCHAR in tree WDBOTTOM */
#define WDLARROW   2 /* BOXCHAR in tree WDBOTTOM */
#define WDHSLIDE   3 /* BOX in tree WDBOTTOM */
#define WDRARROW   4 /* BOXCHAR in tree WDBOTTOM */
#define WDSIZER3   5 /* BOXCHAR in tree WDBOTTOM */


static char string_0[] = {"TEXTE"};
static char string_1[] = {"TOTO1"};
static char string_2[] = {""};
static char string_3[] = {""};

static TEDINFO rs_tedinfo[] = {
	{ string_1, string_2, string_3, 5, 6, 0, 0x11F0, 0x0, 1, 6,1 },
};

static OBJECT rs_object[] = {
/* WDTOP */

	{ -1, 1, 7, G_BOX, FL3DIND|FL3DBAK, NORMAL, {0x11100L}, 1,1, 52,258 }, /* 0x11111L */
	{ 2, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x6011900L}, 0,0, 16,17 },  /* SIZER1 0xE011100L */
	{ 3, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x5011200L}, 16,0, 16,17 }, /* CLOSER */
	{ 4, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x7011B00L}, 32,0, 16,17 }, /* FULLER 0x2A011100L */
	{ 5, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x2D011F00L}, 48,0, 16,17 }, /* SMALLER */
	{ 6, -1, -1, G_STRING, NONE, NORMAL, {(long)string_0}/*{(int)string_0}*/, 64,0, 5000,16 },        /* NAME */
	{ 7, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x6011900L}, 50,0, 16,17 }, /* SIZER2 0xF011100L */
	{ 0, -1, -1, G_BOXTEXT, LASTOB|FL3DBAK, NORMAL, rs_tedinfo, 0,16, 5000,17 },        /* INFO */

/* WDRIGHT */

	{ -1, 1, 4, G_BOX, FL3DIND|FL3DBAK, NORMAL, {0x11148L}, 1,1, 16,8 }, /* 0x11141L */
	{ 2, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x1011C00L}, 0,0, 16,16 },  /* ^ */
	{ 3, -1, -1, G_BOX, FL3DBAK, NORMAL, {0x1112EL}, 0,32, 16,32 },               /* VSLIDE 0x11121L 0xF011100L */
	{ 4, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x6011900L}, 0,64, 16,16 }, /* SIZER5 0x7011100L */
	{ 0, -1, -1, G_BOXCHAR, LASTOB|FL3DIND|FL3DBAK, NORMAL, {0x2011C00L}, 0,6, 16,16 }, /* v */

/* WDLEFT */

	{ -1, -1, -1, G_BOX, LASTOB|FL3DBAK, NORMAL, {0x11100L}, 1,1, 256,9 },

/* WDBOTTOM */

	{ -1, 1, 5, G_BOX, FL3DIND|FL3DBAK, NORMAL, {0x11148L}, 1,1, 36,16 }, /* 0x11141L */
	{ 2, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x6011900L}, 0,0, 16,16 },   /* SIZER4 0xE011100L */
	{ 3, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x4011C00L}, 16,0, 16,16 },  /* <- */
	{ 4, -1, -1, G_BOX, FL3DBAK, NORMAL, {0x1112EL}, 64,0, 48,16 },                /* HSLIDE 0x11121L 0xF011100L*/
	{ 5, -1, -1, G_BOXCHAR, FL3DIND|FL3DBAK, NORMAL, {0x3011C00L}, 32,0, 16,16 },  /* -> */
	{ 0, -1, -1, G_BOXCHAR, LASTOB|FL3DIND|FL3DBAK, NORMAL, {0x6011900L}, 34,0, 16,16 }, /* SIZER3 0x7011100L */
};



/* fin de generation */

long TOP_WIDGETS=NAME|MOVER|CLOSER|FULLER|BACKDROP|SMALLER,
     RIGHT_WIDGETS=UPARROW|DNARROW|VSLIDE,
     LOW_WIDGETS=LFARROW|RTARROW|HSLIDE;



static long CDECL __myaes_widget_around(long widgets, AROUND *autour)
{
	autour->top_height = autour->left_width = autour->right_width = autour->low_height= 1;	/* un simple cadre bord noir + 3D suffit */
	/* occupons-nous d'abord du haut: */
	if (widgets & INFO)	autour->top_height +=16;
	if (widgets & TOP_WIDGETS) autour->top_height +=17;
	/* ensuite le droit: */
	if (widgets & RIGHT_WIDGETS) autour->right_width += 16;
	/* et enfin le bas: */
	if (widgets & LOW_WIDGETS) autour->low_height += 16;
	if ((autour->right_width==1) && (autour->low_height ==1) && (widgets & SIZER) ) autour->right_width += 16;

	if (autour->top_height>1) autour->top_height-=1;
	if (autour->right_width>1) autour->right_width-=1;
	if (autour->low_height>1) autour->low_height-=1;
	if (autour->left_width>1) autour->left_width-=1;

	return 0L;
}


/* recherche du widget  la position donne
	xm, ym: position de la souris relativement au coin haut gauche de la fenetre
	win_width, win_height: largeur hauteur de la fenetre complete (widget inclus donc surface totale)
	renvoi le widget  la position donnee */

static long CDECL __myaes_widget_find( void *window, long xm, long ym, long win_width, long win_height)
{
	long widgets;
	int pos=1;

	my_aes_WIN_VALUES *win_values = call_get_win_values(window);
	widgets = win_values->kind;


	if((16>ym)&&(widgets & TOP_WIDGETS)&&(xm>1))
	{	/* gestion de la barre haut */
		if(widgets & SIZER)
		{	pos+=16;
			if(pos>xm) return WI_ULSIZER; /* presence sizer on en met un aussi dans le coin haut gauche */
		}
		else pos+=2; /* 2 pixels sur le cot */
		if(widgets & CLOSER) pos+=16;
		if(pos>xm) return WI_CLOSER;	/* presence closer */
		if(widgets & FULLER) pos+=16;
		if(pos>xm) return WI_FULLER;	/* presence fuller */
		if(widgets & SMALLER) pos+=16;
		if(pos>xm) return WI_ICONIFIER;	/* prsence iconification */
		if((widgets & SIZER)&&(xm>win_width-16)) return WI_URSIZER; /* resizer en haut  droite */
		if(widgets & MOVER) return WI_MOVER; /* deplacement fenetre possible */
		return 0;	/* rien de reconnu */
	}
	else
	{
		if((16>ym)&&(widgets & INFO)) return 0; /* zone info  trouve pas d'action la dessus */
		else
		{
			if((32>ym)&&(widgets & INFO)&&(widgets & TOP_WIDGETS)) return 0L;  /* zone info  trouve pas d'action la dessus */
			else
			{
				if((ym>win_height-16)&&(widgets & LOW_WIDGETS)&&(xm>1))
				{ /* gestion de la barre du bas */
					long largeurslider;
					if(widgets & SIZER)
					{	pos+=16;
						if(pos>xm) return WI_DLSIZER; /* presence sizer on en met un aussi dans le coin bas gauche */
					}
					if(widgets & LFARROW)
					{	pos+=16;
						if(pos>xm) return WI_LFARROW; /* fleche gauche */
					}
					if(widgets & SIZER)
					{	win_width-=16;
						if(xm>win_width) return WI_DRSIZER; /* resizer en bas  droite */

					}
					if(widgets & RTARROW)
					{	win_width-=16;
						if(xm>win_width) return WI_RTARROW; /* fleche droite */

					}
					/* calcul position ascenseurs */
					largeurslider = win_width - pos;
					if((largeurslider>0) && (widgets & HSLIDE)) /* il y a la place et il y a le slider horizontal */
					{	long cursor_size, cursor_pos;
						cursor_size = ((long)win_values->hslsize * (long)largeurslider / 1000L);
						if(largeurslider>20 && cursor_size<16) cursor_size=16;
						cursor_pos = (((largeurslider - cursor_size) * (long)win_values->hslide) / 1000L) + pos;
						if(xm<cursor_pos) return WI_HBARLEFT;
						if(xm>cursor_pos+cursor_size) return WI_HBARRIGHT;
						return WI_HCURSOR;
					}
				}
				else
				if((xm>win_width-16)&&(widgets & (RIGHT_WIDGETS|SIZER)))
				{ /* gestion de la barre sur le cote */
					long largeurslider;
					if(widgets & INFO) pos+=16;
					if(widgets & TOP_WIDGETS) pos+=16;
					if(widgets & UPARROW)
					{	pos+=16;
						if(pos>ym) return WI_UPARROW;
					}
					if(widgets & SIZER)
					{
						win_height-=16;
						if(ym>win_height) return WI_DRSIZER; /* presence sizer on en met un aussi dans le coin bas gauche */

					}
					if(widgets & DNARROW)
					{	win_height-=16;
						if(ym>win_height) return WI_DNARROW;
						
					}
					/* calcul position ascenseurs */
					largeurslider = win_height - pos;
					if((largeurslider>0) && (widgets & VSLIDE)) /* il y a la place et il y a le slider horizontal */
					{	long cursor_size, cursor_pos;
						cursor_size = ((long)win_values->vslsize * (long)largeurslider / 1000L);
						if(largeurslider>20 && cursor_size<16) cursor_size=16;
						cursor_pos = (((largeurslider - cursor_size) * (long)win_values->vslide) / 1000L) + pos;
						if(ym<cursor_pos) return WI_VBARUP;
						if(ym>cursor_pos+cursor_size) return WI_VBARDOWN;
						return WI_VCURSOR;
					}
				}
			}
		}
	}
	
	return 0L;
}
/* fonction de recherche du rectangle incluant un widget donne (pour preparation avant redraw) 
	la fonction doit retourner ces infos */
static long CDECL __myaes_widget_position(void *window, long widget, GRECT *xywh_widget)
{
	short x, y, w, h;
	unsigned short widgets;
	GRECT *pos;

	my_aes_WIN_VALUES *win_values = call_get_win_values(window);


  pos = call_get_win_rect( window);
	widgets = (unsigned short)win_values->kind;

	switch ((int)widget)
	{
		case CLOSER:
			if (! (widgets & CLOSER))
				x = y = w = h = 0;
			else
			{
				x = y = 0;
				if (widgets & SIZER)
					x += 16;
				w = 16;
				h = 16;
			}
		break;
		case MOVER:
			if (! (widgets & NAME))
				x = y = w = h = 0;
			else
			{
				x = 0;
				y = 0;
				if (widgets & SIZER)
					x += 16;
				if (widgets & CLOSER)
					x += 16;
				if (widgets & SMALLER)
					x += 16;
				if (widgets & FULLER)
					x += 16;
				w = pos->g_w - x - ((widgets & SIZER) ? 16 : 0);
				h = 16;
			}
		break;
		case INFO:
			if (! (widgets & INFO))
				x = y = w = h = 0;
			else
			{
				x = 0;
				y = 16;
				w = pos->g_w;
				h = 16;
			}
		break;
		case VSLIDE:
			x = pos->g_w - 16;
			y = 0;
			if(widgets & (MOVER|SMALLER|CLOSER|FULLER)) y=16;
			if (widgets & INFO)
				y += 16;
			if (widgets & UPARROW)
				y += 16;
			w = 16;
			h = pos->g_h - y;
			if ((widgets & SIZER) || (widgets & HSLIDE))
				h -= 16;
			if (widgets & DNARROW)
				h -= 16;

		break;
		case HSLIDE:
			x = (widgets & SIZER) ? 16 : 1;
			if (widgets & LFARROW)
				x += 16;
			y = pos->g_h - 16;
			w = pos->g_w - x;
			h = 16;
			if ((widgets & SIZER) || (widgets & VSLIDE))
				w -= 16;
			if (widgets & RTARROW)
				w -= 16;

		break;
		default:
			x = y = w = h = 0;
	}


	xywh_widget->g_x = x + pos->g_x;
	xywh_widget->g_y = y + pos->g_y;
	xywh_widget->g_w = w;
	xywh_widget->g_h = h;

	return 0L;
}

static void * CDECL __myaes_widget_userdef(long widget,long click, long shift)   /* actually not use by MyAES */
{
	return NULL;
}

static void CDECL __myaes_widget_close(void)
{
}

static int largeur_slide(int val, int largeur_zone)
{	int retour;
	 retour = (int)(((long)val * (long)largeur_zone)/1000L);
	 if((retour<16)&&(largeur_zone > 20)) /* le slide est trop petit on ne peut pas le saisir */
	 {
	 	retour = 16;
	 }
	 if(retour==0) retour=2;
	 return retour;
}

static int position_slide(int val, int largeur_zone, int _largeur_slide)
{
	return (int)(((long)(largeur_zone - _largeur_slide)*(long)val)/1000L);
}

static OBJECT * CDECL __myaes_widget_tree(void *window, long mode, void *client)
{	OBJECT *tree=NULL;

  GRECT *wingrect = call_get_win_rect( window);
  my_aes_WIN_VALUES *win_values = call_get_win_values(window);
  my_aes_WIN_STRINGS *win_strings = call_get_win_strings (window);
  long kind = win_values->kind; int taille=0, position=0;

	switch(mode)
	{
		case LEFT_BORDER:
			tree=&rs_object[WDLEFT];
			tree->ob_height = wingrect->g_h;
			tree->ob_x = wingrect->g_x;
			tree->ob_y = wingrect->g_y;
		break;
		case UP_BORDER:
			tree=&rs_object[WDTOP];
			tree[WDINFOS].ob_width=tree->ob_width = wingrect->g_w;
			tree->ob_x = wingrect->g_x;
			tree->ob_y = wingrect->g_y;
			if(kind&TOP_WIDGETS) tree->ob_height = 17;
			else tree->ob_height = 1;
			if(kind&INFO)
                        {
                          tree->ob_height+=16;
                          tree[WDINFOS].ob_flags&=~HIDETREE;
                        }
                        else
                        {
                            tree[WDINFOS].ob_flags|=HIDETREE;
                        }
			tree[WDNAME].ob_spec.free_string = win_strings->name;
			rs_tedinfo[0].te_ptext =  win_strings->info;
			tree[WDSIZER2].ob_x=tree->ob_width-16;
			if(kind&SIZER)
			{
				tree[WDSIZER1].ob_flags&=~HIDETREE;
				tree[WDSIZER2].ob_flags&=~HIDETREE;
				position+=16;
			}
			else
			{
				tree[WDSIZER1].ob_flags|=HIDETREE;
				tree[WDSIZER2].ob_flags|=HIDETREE;
			}
			if(kind&CLOSER)
			{
				tree[WDCLOSER].ob_flags&=~HIDETREE;
				tree[WDCLOSER].ob_x=position;
				position+=16;
			}
			else
			{
				tree[WDCLOSER].ob_flags|=HIDETREE;
			}
			if(kind&FULLER)
			{
				tree[WDFULLER].ob_flags&=~HIDETREE;
				tree[WDFULLER].ob_x=position;
				position+=16;
			}
			else
			{
				tree[WDFULLER].ob_flags|=HIDETREE;
			}
			if(kind&SMALLER)
			{
				tree[WDSMALLE].ob_flags&=~HIDETREE;
				tree[WDSMALLE].ob_x=position;
				position+=16;
			}
			else
			{
				tree[WDSMALLE].ob_flags|=HIDETREE;
			}
			if(kind&NAME)
			{
				tree[WDNAME].ob_flags&=~HIDETREE;
				tree[WDNAME].ob_x=position;
				position+=16;
			}
			else
			{
				tree[WDNAME].ob_flags|=HIDETREE;
			}

		break;
		case RIGHT_BORDER:

			tree=&rs_object[WDRIGHT];
			if(kind&RIGHT_WIDGETS) tree->ob_width = 16;
			else tree->ob_width = 1;
			tree->ob_x = wingrect->g_x+wingrect->g_w-tree->ob_width;
			if(kind&TOP_WIDGETS) taille+=16;
			else taille+=1;
			if(kind&INFO) taille+=16;
			tree->ob_y = wingrect->g_y+taille;
			if((kind&LOW_WIDGETS)||((kind&SIZER)&&((kind&RIGHT_WIDGETS)==0))) taille+=16;
			else taille+=1;
			tree->ob_height = wingrect->g_h-taille;
			if((!(kind&LOW_WIDGETS))&&(kind&SIZER))
			{
				tree[WDBARROW].ob_y = tree->ob_height -32;
				tree[WDSIZER5].ob_y = tree->ob_height -16;
			}
			else
			{
				tree[WDBARROW].ob_y = tree->ob_height -16;
				tree[WDSIZER5].ob_y = tree->ob_height;
			}
			if(kind&UPARROW)
			{
				tree[WDTARROW].ob_flags&=~HIDETREE;
				position+=16;
			}
			else
			{
				tree[WDTARROW].ob_flags|=HIDETREE;
			}

			if(kind&DNARROW)
			{
				tree[WDBARROW].ob_flags&=~HIDETREE;
			}
			else
			{
				tree[WDBARROW].ob_flags|=HIDETREE;
				tree[WDBARROW].ob_y +=16;
			}

			if(kind&VSLIDE)
			{
				tree[WDVSLIDE].ob_flags&=~HIDETREE;
				tree[WDVSLIDE].ob_height = largeur_slide(win_values->vslsize, tree[WDBARROW].ob_y - position);
				tree[WDVSLIDE].ob_y = position + position_slide(win_values->vslide, tree[WDBARROW].ob_y - position, tree[WDVSLIDE].ob_height);
			}
			else
			{
				tree[WDVSLIDE].ob_flags|=HIDETREE;
			}



		break;
		case DOWN_BORDER:

			tree=&rs_object[WDBOTTOM];
			tree->ob_width = wingrect->g_w-1;
			if((kind&LOW_WIDGETS)||((kind&SIZER)&&((kind&RIGHT_WIDGETS)==0))) tree->ob_height = 16;
			else tree->ob_height = 1;
			tree->ob_x = wingrect->g_x;
			tree->ob_y = wingrect->g_y+wingrect->g_h-tree->ob_height;
			if(kind&SIZER)
			{
				tree[WDSIZER3].ob_x=tree->ob_width-16;
				tree[WDRARROW].ob_x=tree->ob_width-32;
				position+=16;
			}
			else
			{
				tree[WDSIZER3].ob_x=tree->ob_width;
				tree[WDRARROW].ob_x=tree->ob_width-16;
			}

			if(kind&LFARROW)
			{
				tree[WDLARROW].ob_flags&=~HIDETREE;
				position+=16;
			}
			else
			{
				tree[WDLARROW].ob_flags|=HIDETREE;
			}

			if(kind&RTARROW)
			{
				tree[WDRARROW].ob_flags&=~HIDETREE;
			}
			else
			{
				tree[WDRARROW].ob_flags|=HIDETREE;
				tree[WDRARROW].ob_x+=16;
			}

			if(kind&HSLIDE)
			{
				tree[WDHSLIDE].ob_flags&=~HIDETREE;
				tree[WDHSLIDE].ob_width = largeur_slide(win_values->hslsize, tree[WDRARROW].ob_x - position);
				tree[WDHSLIDE].ob_x = position + position_slide(win_values->hslide, tree[WDRARROW].ob_x - position, tree[WDHSLIDE].ob_width);
			}
			else
			{
				tree[WDHSLIDE].ob_flags|=HIDETREE;
			}


		break;
		default: break;
	}

	return tree;
}


char *CDECL information(void);
void CDECL (widget_init)(WIDGETS_UTILS *utils);

char *CDECL information(void)     /* information about this LDG */
{
	return ("Widgets simple pour MyAeS Olivier Landemarre");
}

void CDECL (widget_init)(WIDGETS_UTILS *utils)     /* you can use it to initialize what you need before start redraw anything
                                                   there is in utils a lot of helpfull function addresses to help transform picture
                                                   in the actual resolution */
{
  widgets_utils = utils;
}

/*
 * tableau de taille  modifier pour mettre toutes
 * les addresses des procdures  prsenter
 */

PROC LibFunc[] = {
"information", "/* Retourne une chaine info sur la lib*/\n"
			   "char *information( VOID);\n", information,
"widget_init", "/* Rcupre une structure de MyAeS avec tout plein de fonctions utiles pour le widget qui peuvent etre utilises directement dont les transformations graphiques de 24 bits vers format cran */\n"
			   "void cdecl (widget_init)(WIDGETS_UTILS *fcts);\n", widget_init,
"widget_userdef", "/* Retourne l'adresse d'une fonction si le widget est gr par l'utilisateur, sinon 0L */\n"
			   "long cdecl widget_userdef (long widget,long click, long shift);\n", __myaes_widget_userdef,
"widget_around", "/* fonction qui renseigne ce qu'il y a autour de la zone de travail pris par les widgets */\n"
			   "long cdecl widget_around( long widget, AROUND *autour);\n", __myaes_widget_around,
"widget_find", "/*  recherche du widget  la position donne*/\n"
			   "long cdecl  widget_find( void *window, long xm, long ym, long win_width, long win_height);\n", __myaes_widget_find,
"widget_position", "/* recherche de la position d'un widget donn */\n"
				"long cdecl widget_position(void *window, long widget, GRECT *xywh_widget);\n", __myaes_widget_position,
"widget_tree", "/* renvoi un arbre  afficher (en 4 morceaux) */\n"
				"OBJECT *cdecl widget_tree (void *window, long mode,void *client);\n", __myaes_widget_tree,
"widget_close","void widget_close(void) fermeture pour quitter proprement",__myaes_widget_close
			    };

LDGLIB LibLdg[]={
				  0x0100,	/* version de la lib */
				  8,		/* nombre de fonctions dans la lib */
				  LibFunc,	/* Adresse des fonctions */
				  "Librairie de gestion des widgets pour MyAeS",	/* Chaine d'information */
				  LDG_NOT_SHARED    		/* Flags de la lib, obligatoire, cette lib est uniquement pour MyAeS elle ne sera pas partage */
				};


int main (void)
{
	ldg_init (LibLdg);
	return (0);
}


